#include "exp1.rc"
#define DS2401 0x01
#define  ID_LISTBOX 100


typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

uint global_time_interval = 10;
uint comport = 2, num_waits = 0, old_num_waits = 0;
TPoint location(0, 0);

/***********************Function types from TMEX*******************************/
extern "C" 
{
	int   far pascal TMSetup(int);
	int	far pascal TMStartSession(int);
   int   far pascal TMValidSession(int);
	int	far pascal TMEndSession(int);
	int	far pascal TMValidSession(int);
	int	far pascal TMNext(int, uchar far *);
	int	far pascal TMRom(int, uchar far *, int far *);
	int 	far pascal TMFirst(int, uchar far *);
	int   far pascal TMAccess(int, uchar far *);
	int   far pascal TMStrongAlarmAccess(int, uchar far *);
}

//==============================================================================
// function declarations
//==============================================================================
struct tnode far *talloc(void);
struct tnode *addtree(struct tnode far *, int rom1[8]);
int agetree(struct tnode *);
int Check_Tree();
struct tnode *search_tree(struct tnode *p, int rom1[8]);
char *strdup1(char *s);
int agetreenull(struct tnode *p);


// memory model functions that will work with Large Memory Model.
void mstrcpy(char far *dest, char far *src);
void mmemcpy(uchar far *dest, uchar far *src, uchar transnum);
int mmemcmp(uchar far *ml, uchar far *m2, int n);

//==============================================================================
// global variable declarations
//==============================================================================
char filen[81];
char rom_buffer[40];
TClientDC *dc;
int handle;    // handle for TMEX
uchar GB[15280]; // garbage bag array for TMEX
int Ren_ok_flag;
int add_device;                                                   
int rom[8];
char new_name[25];
int age_flag;
int already_loging = FALSE;
int kill_timer_flag = FALSE;

int log_pass_flag = 2; // 0 = log all passes, 1 = log alarming passes, 2 = log changed passes

struct tnode
{
	char word[25];  //name of device
   int ROMID[8];   //rom id
	int ageflag;    //whether it was found the last pass or not
	int count;      //how many devices are connected
   char present[10]; //contains info on device found or not found;
	struct tnode *left;  //pointer to node on left
	struct tnode *right; //pointer to node on right
};

struct tnode far *root;
class TDecoChild;
TDecoChild *cp;
WORD FAR PASCAL Save(HWND, WORD, WORD, LONG);
UINT ID_MYTIMER;
int timecount = WAIT_TIME; //set for the amount of time between autosaves;
int szmissing = 0;
int timer_set_flag = FALSE;
int switchflag = FALSE;
int previous_flag = FALSE;
int fill_array_with_info(struct tnode *p);
char device_array[40][40];
int num_devices;
int out_stream;
int in_stream;
int log_file_open_flag = 0;
